SystemOrganization addCategory: #Proxies!

ProtoObject subclass: #CompiledMethodProxy
	instanceVariableNames: 'oldMethod reference executed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 11:59'!
installOn: aClass selector: aSel
	| newInst |
	newInst := (self on: aClass selector: aSel)  install.
	^ newInst! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
on: aMethodReference
	^self new initializeFor: aMethodReference ! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 10/18/2010 11:57'!
doesNotUnderstand: aMessage
	Transcript show: 'CompiledMethodProxy dnu: ', aMessage asString.
	^ oldMethod isNil
		ifTrue: [
			"It was not installed"
			super doesNotUnderstand: aMessage]
		ifFalse: [
			"It was installed, thus, I should uninstall it"
			self uninstall.
			oldMethod perform: aMessage selector withArguments: aMessage arguments.
			]! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 11:24'!
executed
	^ executed! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 11:24'!
executed: anObject
	executed := anObject! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 10:47'!
flushCache
	"This method should be implemented because otherwise there are errors."! !

!CompiledMethodProxy methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/18/2010 10:53'!
initialize

	super initialize.
	executed := false! !

!CompiledMethodProxy methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
initializeFor: aMethodReference 
	reference := aMethodReference.! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 11:03'!
install
	[oldMethod := self wrappedClass lookupSelector: self selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod uninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	Transcript show: 'The method', self selector asString, 'is being wrapped'; cr.
	self wrappedClass methodDict at: self selector put: self! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
oldMethod
	"Answer the value of oldMethod"

	^ oldMethod! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
oldMethod: anObject
	"Set the value of oldMethod"

	oldMethod := anObject! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
reference
	^ reference ! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 11:02'!
run: aSelector with: arguments in: aReceiver

	| aResult |
	Transcript show: 'The method', aSelector asString, 'is being executed'; cr.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self executed: true.
	Transcript show: 'The method', aSelector asString, 'wasexecuted'; cr.
	self uninstall.
	Transcript show: 'The method proxy was uninstalled'; cr.
	^aResult
	! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
selector
	"Answer the value of selector"

	^ reference selector! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
uninstall

	oldMethod isNil ifTrue: [^self].
	"self wrappedClass removeSelectorSilently: self selector.
	self wrappedClass addSelector: self selector withMethod: oldMethod.
	"
	self wrappedClass methodDict at: self selector put: oldMethod  

! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
wrappedClass
	"Answer the value of wrappedClass"

	^ reference actualClass! !

ProtoObject subclass: #CompiledMethodProxyReferenceStream
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 16:17'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:12'!
on: aMethodReference
	^self new installFor: aMethodReference ! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxyReferenceStream methodsFor: 'testing' stamp: 'MarianoMartinezPeck 10/18/2010 15:27'!
doesNotUnderstand: aMessage
	| oldMethod |
	Transcript show: 'CompiledMethodProxy dnu: ', aMessage asString.
	^ fileName isNil
		ifTrue: [
			"It was not installed"
			super doesNotUnderstand: aMessage]
		ifFalse: [
			"It was installed, thus, I should uninstall it"
			oldMethod := self uninstall.
			oldMethod perform: aMessage selector withArguments: aMessage arguments.
			]! !

!CompiledMethodProxyReferenceStream methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
flushCache
	"This method should be implemented because otherwise there are errors."! !

!CompiledMethodProxyReferenceStream methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 16:21'!
installFor: aMethodReference
	| oldMethod oldClass selector |
	oldClass := aMethodReference actualClass. 
	selector := aMethodReference  selector. 
	[oldMethod := oldClass lookupSelector: selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod uninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	Transcript show: 'The method', selector asString, 'is being wrapped'; cr.
	fileName := self writeMethodOnDisk: oldMethod.
	oldClass methodDict at: selector put: self.
	! !

!CompiledMethodProxyReferenceStream methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 15:51'!
loadCompiledMethodFrom: aFileName
	| refStream aCompiledMethod |
	refStream := ReferenceStream fileNamed: 'test.obj'.
	aCompiledMethod := refStream next.
	refStream close.
	^ aCompiledMethod! !

!CompiledMethodProxyReferenceStream methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 15:26'!
run: aSelector with: arguments in: aReceiver

	| aResult oldMethod |
	Transcript show: 'The method proxy was uninstalled'; cr.
	oldMethod := self uninstall.
	Transcript show: 'The metshod', aSelector asString, 'is being executed'; cr.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	Transcript show: 'The method', aSelector asString, 'wasexecuted'; cr.
	^aResult
	! !

!CompiledMethodProxyReferenceStream methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 16:24'!
uninstall
	| oldMethod |
	fileName isNil ifTrue: [^self].
	"self wrappedClass removeSelectorSilently: self selector.
	self wrappedClass addSelector: self selector withMethod: oldMethod.
	"
	oldMethod := self loadCompiledMethodFrom: fileName.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	^ oldMethod.  

! !

!CompiledMethodProxyReferenceStream methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/18/2010 15:51'!
writeMethodOnDisk: aCompiledMethod
	| refStream | 
	refStream := ReferenceStream fileNamed: 'test.obj'.
	refStream nextPut: aCompiledMethod.
	refStream close.! !

ProtoObject subclass: #ObjectProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 15:39'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy3 new.
p become: MyClass.
MyClass flushCache.
ClassProxy3 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:51'!
forFileName: aFileName
	^ self new fileName: aFileName ! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2010 19:54'!
become: anObject
	fileName := self serializeAndWriteToDisk: anObject.
	"anObject becomeForward: self. "
	super become: anObject. ! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2010 20:44'!
doesNotUnderstand: aMessage
	Transcript show: 'Message not understood:', aMessage asString; cr.
	Transcript show: 'Will restore object'; cr.
	self become: self loadBackSerializedObjectsFromFile.
	Transcript show: 'Object was restored'; cr.
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 16:19'!
fileName
	^ fileName! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 16:19'!
fileName: anObject
	fileName := anObject! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomethingProxy'! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:49'!
loadBackSerializedObjectsFromFile

	| file result |
	file := FileStream fileNamed: self fileName.
	file binary.
	result := (ReferenceStream on: file) next.
	file close.
	^ result! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2010 17:09'!
serializeAndWriteToDisk: anObject	
	| file result |

	file := FileStream fileNamed: (self name, ' test').
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ self name, ' test'.! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 10/17/2010 20:38'!
name 
	^ self niDescription
	! !

Object subclass: #ClassProxyFileOut
	instanceVariableNames: 'superclass methodDict format className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/17/2010 17:02'!
become: aClass
	| classNameBkp |
	className := aClass name.
	"FileDirectory default  deleteFileNamed: aClass name, '.st'  ifAbsent: [].
	"aClass fileOut.
	"Smalltalk removeClassNamed: className.
	"
	super become: aClass
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:49'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:52'!
fileInClass.
	(FileStream fileNamed: className, '.st') fileIn.
	^ Smalltalk at: className. 
	! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:50'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 20:08'!
restore
	Transcript show: 'Will restore class'; cr.
	super become: self fileInClass.
	Transcript show: 'Class restored'; cr.
! !

Object subclass: #ClassProxyInstVar
	instanceVariableNames: 'superclass methodDict format actualClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:04'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 10/1/2010 14:57'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
	actualClass := self! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/2/2010 19:28'!
restore
	Transcript show: 'Will restore class'; cr.
	self become: actualClass.
	Transcript show: 'Class restored'; cr.
! !

Object subclass: #ObjectSwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/30/2010 10:03'!
serializeAndWriteToDisk: anObject	
	| file result |

	file := FileStream fileNamed: (self name, ' test').
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ self name, ' test'.! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/30/2010 16:43'!
swap: anObject
	| fileName proxy |
	fileName := self serializeAndWriteToDisk: anObject. 
	
	"make this nicer"
	anObject isBehavior 
		ifTrue: [proxy := AClassProxy forFileName: fileName.]
		ifFalse: [proxy := ObjectProxy forFileName: fileName.].
	
	anObject becomeForward: proxy. ! !

Object subclass: #ProxySuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ProxySuperclass methodsFor: 'swapping' stamp: 'NouryBouraqadi 10/1/2010 15:08'!
cannotInterpret: aMessage
	Transcript cr; 
		show: 'cannotInterpret:';
		space;
		show: aMessage selector..
	self class restore.
	^aMessage sendTo: self! !
